Simplified the character-class code a bit.
[rsync/rsync.git] / testsuite / rsync.fns
... / ...
CommitLineData
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
6
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
21TMP="$scratchdir"
22FROM=${TMP}/from
23TO=${TMP}/to
24LOG=${TMP}/log
25RSYNC="$rsync_bin"
26
27# Berkley's nice.
28PATH="$PATH:/usr/ucb"
29
30runtest() {
31 echo $ECHO_N "Test $1: $ECHO_C"
32 if eval "$2"
33 then
34 echo "${ECHO_T} done."
35 return 0
36 else
37 echo "${ECHO_T} failed!"
38 return 1
39 fi
40}
41
42printmsg() {
43 echo "$1"
44}
45
46
47rsync_ls_lR() {
48 find "$@" -print | sort | xargs "$TOOLDIR/tls"
49}
50
51rsync_getgroups() {
52 "$TOOLDIR/getgroups"
53}
54
55
56####################
57# Build test directories TO and FROM, with FROM full of files.
58
59hands_setup() {
60 # Clean before creation
61 rm -rf $FROM
62 rm -rf $TO
63
64 [ -d $TMP ] || mkdir $TMP
65 [ -d $FROM ] || mkdir $FROM
66 [ -d $TO ] || mkdir $TO
67
68 # On some BSD systems, the umask affects the mode of created
69 # symlinks, even though the mode apparently has no effect on how
70 # the links behave in the future, and it cannot be changed using
71 # chmod! rsync always sets its umask to 000 so that it can
72 # accurately recreate permissions, but this script is probably run
73 # with a different umask.
74
75 # This causes a little problem that "ls -l" of the two will not be
76 # the same. So, we need to set our umask before doing any creations.
77
78 # set up test data
79 touch ${FROM}/empty
80 mkdir ${FROM}/emptydir
81
82 # a hundred lines of text or so
83 rsync_ls_lR "${srcdir}" > ${FROM}/filelist
84
85 # This might fail on systems that don't have -n
86 echo $ECHO_N "This file has no trailing lf$ECHO_C" > ${FROM}/nolf
87 umask 0
88 ln -s nolf ${FROM}/nolf-symlink
89 umask 022
90
91 cat $srcdir/*.c > ${FROM}/text
92 mkdir ${FROM}/dir
93 cp ${FROM}/text ${FROM}/dir
94 mkdir ${FROM}/dir/subdir
95 mkdir ${FROM}/dir/subdir/subsubdir
96 ls -ltr /etc > ${FROM}/dir/subdir/subsubdir/etc-ltr-list
97 mkdir ${FROM}/dir/subdir/subsubdir2
98 ls -lt /bin > ${FROM}/dir/subdir/subsubdir2/bin-lt-list
99
100# echo testing head:
101# ls -lR ${srcdir} | head -10 || echo failed
102}
103
104
105####################
106# Many machines do not have "mkdir -p", so we have to build up long paths.
107# How boring.
108makepath () {
109 echo " makepath $1"
110 p="$1"
111 (
112 # Absolut Unix.
113 if echo $p | grep '^/' >/dev/null
114 then
115 cd /
116 fi
117
118 # This will break if $1 contains a space.
119 for c in `echo $p | tr '/' ' '`
120 do
121 if [ -d "$c" ] || mkdir "$c"
122 then
123 cd "$c" || return $?
124 else
125 echo "failed to create $c" >&2; return $?
126 fi
127 done
128 )
129}
130
131
132
133###########################
134# Run a test (in '$1') then compare directories $2 and $3 to see if
135# there are any difference. If there are, explain them.
136
137# So normally basically $1 should be an rsync command, and $2 and $3
138# the source and destination directories. This is only good when you
139# expect to transfer the whole directory exactly as is. If some files
140# should be excluded, you might need to use something else.
141
142checkit() {
143 failed=
144
145 # We can just write everything to stdout/stderr, because the
146 # wrapper hides it unless there is a problem.
147
148 echo "Running: \"$1\""
149 eval "$1"
150 status=$?
151 if [ $status != 0 ]; then
152 failed="YES";
153 fi
154
155 echo "-------------"
156 echo "check how the files compare with diff:"
157 echo ""
158 for f in `cd "$2"; find . -type f -print `
159 do
160 diff -c "$2"/"$f" "$3"/"$f" || failed=YES
161 done
162
163 echo "-------------"
164 echo "check how the directory listings compare with diff:"
165 echo ""
166 ( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from
167 ( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to
168 diff -c ${TMP}/ls-from ${TMP}/ls-to || failed=YES
169 if [ -z "${failed}" ] ; then
170 return 0
171 else
172 return 1
173 fi
174}
175
176
177build_rsyncd_conf() {
178 # Build an appropriate configuration file
179 conf="$scratchdir/test-rsyncd.conf"
180 echo "building configuration $conf"
181
182 port=2612
183 pidfile="$scratchdir/rsyncd.pid"
184 logfile="$scratchdir/rsyncd.log"
185
186 cat >$conf <<EOF
187# rsyncd configuration file autogenerated by $0
188
189pid file = $pidfile
190use chroot = no
191hosts allow = localhost, 127.0.0.1
192log file = $logfile
193
194uid = 0
195gid = 0
196
197[test-from]
198 path = $FROM
199 read only = yes
200
201[test-to]
202 path = $TO
203 read only = no
204EOF
205}
206
207
208build_symlinks() {
209 fromdir="$scratchdir/from"
210 todir="$scratchdir/to"
211 mkdir "$fromdir"
212 date >"$fromdir/referent"
213 ln -s referent "$fromdir/relative"
214 ln -s "$fromdir/referent" "$fromdir/absolute"
215 ln -s nonexistent "$fromdir/dangling"
216 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
217}
218
219test_fail() {
220 echo "$@" >&2
221 exit 1
222}
223
224test_skipped() {
225 echo "$@" >&2
226 echo "$@" > "$TMP/whyskipped"
227 exit 77
228}
229
230# It failed, but we expected that. don't dump out error logs,
231# because most users won't want to see them. But do leave
232# the working directory around.
233test_xfail() {
234 echo "$@" >&2
235 exit 78
236}
237
238# Determine what shell command will appropriately test for links.
239ln -s foo "$scratchdir/testlink"
240for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
241do
242 for switch in -h -L
243 do
244 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
245 then
246 # how nice
247 TEST_SYMLINK_CMD="$cmd $switch"
248 # i wonder if break 2 is portable?
249 break 2
250 fi
251 done
252done
253# ok, now get rid of it
254rm "$scratchdir/testlink"
255
256
257if [ "x$TEST_SYMLINK_CMD" = 'x' ]
258then
259 test_fail "Couldn't determine how to test for symlinks"
260else
261 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
262fi
263
264
265# Test whether something is a link, allowing for shell peculiarities
266is_a_link() {
267 # note the variable contains the first option and therefore is not quoted
268 $TEST_SYMLINK_CMD "$1"
269}
270
271
272# We need to set the umask to be reproducible. Note also that when we
273# do some daemon tests as root, we will setuid() and therefore the
274# directory has to be writable by the nobody user in some cases. The
275# best thing is probably to explicitly chmod those directories after
276# creation.
277
278umask 022